export declare type ErrorCode = {
    [key: string]: {
        code: string;
        params: {
            [key: string]: string | number | boolean;
        };
    }[];
};
export declare type ErrorPayload = {
    codes?: ErrorCode;
} & {
    [key: string]: string[];
};
export declare class SocketCommandError {
    readonly command: string;
    readonly message: string;
    readonly payload?: ErrorPayload;
    constructor(command: string, message: string, payload?: ErrorPayload);
    static CreateFromDatabaseError(command: string, err: any): SocketCommandError;
}
export declare class ActionExpectationError {
    readonly message?: string;
    readonly payload?: ErrorPayload;
    readonly error: string;
    readonly statusCode: number;
    constructor(message?: string, payload?: ErrorPayload, error?: string, statusCode?: number);
    static CreateFromErrorCode(codes: ErrorCode): ActionExpectationError;
    static CreateFromDatabaseError(err: any): ActionExpectationError;
}
