/// <reference types="node" />
import { Server, Socket } from 'socket.io';
import SocketIOServer = require('socket.io');
import * as http from 'http';
import { Server as KamandServer } from '../server';
import { EventListener } from './interfaces';
export declare type SockIOMiddleware = (socket: Socket, fn: (err?: any) => void) => void;
export declare type KamandSocket = Socket & {
    user: any;
};
export declare type FutureUpdate = {
    socket: KamandSocket;
    payload: any;
};
export declare class WebSocketService {
    private server;
    private host;
    private port;
    private io;
    readonly httpServer: http.Server;
    readonly listeners: EventListener[];
    private options;
    private futureUpdates;
    private futureUpdateKeys;
    constructor(server: KamandServer, host: string, port: number);
    use(fn: SockIOMiddleware): SocketIOServer.Namespace;
    registerListener(listener: EventListener): void;
    connection: (socket: KamandSocket) => void;
    authorize: (socket: KamandSocket, data: string) => void;
    disconnected: (socket: KamandSocket, reason: string) => void;
    error: (socket: KamandSocket, error: any) => void;
    getIo(): Server;
    start(): Promise<void>;
    stop(): Promise<void>;
    addForFutureUpdate(key: string, socket: KamandSocket, payload: any): void;
    removeForFutureUpdate(key: string, socket: KamandSocket): void;
    findForFutureUpdate(key: string): FutureUpdate[];
    addFutureUpdateKey(socketId: string, key: string): void;
    removeFutureUpdateKey(socketId: string, key: string): void;
    removeForFutureUpdateBySocket(socket: KamandSocket): void;
}
