"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.stripAnyThingButDigits = exports.mapToLatin = exports.mapToFarsi = void 0;
function mapToFarsi(str) {
    if (!str && str !== 0)
        return str;
    return str.toString().replace(/[1234567890١٢٣٤٥٦٧٨٩٠]/gi, e => { const c = e.charCodeAt(0); return String.fromCharCode(c + (c < 60 ? 1728 : 144)); });
}
exports.mapToFarsi = mapToFarsi;
function mapToLatin(str) {
    if (!str && str !== 0)
        return str;
    return str.toString().replace(/[۱۲۳۴۵۶۷۸۹۰١٢٣٤٥٦٧٨٩٠]/gi, e => { const c = e.charCodeAt(0); return String.fromCharCode(c - (c < 1770 ? 1584 : 1728)); });
}
exports.mapToLatin = mapToLatin;
function stripAnyThingButDigits(str) {
    if (!str)
        return str;
    return str.toString().replace(/[^1234567890۱۲۳۴۵۶۷۸۹۰١٢٣٤٥٦٧٨٩٠]/gi, '');
}
exports.stripAnyThingButDigits = stripAnyThingButDigits;
//# sourceMappingURL=farsiUtils.js.map